<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script>
      /*
      Напишите класс User, который будет использоваться для создание объекта,
      описывающиго пользователя панели администрирования сайта.
      У объекта должны быть такие поля:
      - role (super admin, admin, main manager, content manager);
      - login;
      - email;
      - password;

      сеттеры и геттеры:
      - role (можно установить роль только из списка: super admin, admin, main manager, content manager);
      - login (не меньше трех букв);

      а также метод:
      - isValidEmail - проверят, является ли переданная строка email'ом (в ней должен быть символ @, минимум 1 точка и не должно быть пробелов);

      Дополнительное задание: добавьте метод getPasswordStrength, который проверяет силу пароля. Метод получает строку (пароль) и возвращает один из трех вариантов:
      - weak - меньше 6 символов, не содержимт букв или цифр;
      - medium - больше 6 символов, содержит цифры и буквы, но не содержит знаков: -_^$%#@*&?
      - strong - больше 6 символов, содержит буквы, цифры и спецсимволы: -_^$%#@*&?
      */

      class User {
        constructor(role, login, email, password) {
          this._role = role;
          this._login = login;
          this.email = email;
          this.password = password;
        }
        get role () {
          return this._role;
        }
        set role (newRole) {
          const arrayRole = ['super admin', 'admin', 'main manager', 'content manager'];
          if(arrayRole.includes(newRole)) {
            this._role = newRole;
          }
        }
        get login () {
          return this._login;
        }
        set login (newLogin) {
          if(newLogin.length >= 3 ) {
            this._login = newLogin;
          }
      }
      isValidEmail(string) {
        return string.includes('@') && string.includes('.') && !string.includes(' ');
      }
    }
    const newUser = new User ('admin', 'Anton', 'asdsd@dfdsf.com', 'qwerty1234');
    console.log(newUser.isValidEmail(' ')); 
      // class User{

      //   constructor(role, login, email, password){
      //     this._role = role;
      //     this.login = login;
      //     this.email = email;
      //     this._password = password;
      //   }

      //   get role() {
      //     return this._role;
      //   }

      //   set role(newRole) {
      //     const arrayRole = ['super admin', 'admin', 'main manager', 'content manager'];
      //     if (arrayRole.includes(newRole)){
      //       this._role = newRole;
      //     }
      //   }

      //   get password() {
      //     return this._password;
      //   }

      //   set password(newPassword) {
      //     if (newPassword.length >= 3){
      //       this._password = newPassword;
      //     }
      //   }

      //   isValidEmail(string){
      //       return string.includes('@') && string.includes('.') && !string.includes(' ')
      //   }

      // }


      

      // const ourUser = new User('admin', 'vladertec', 'sarnavsk2001@ukr.net', 'qwerty12345');
      // console.log(ourUser.isValidEmail('d123'));
    </script>
  </body>
</html>
